//
// by Boris Stefanovic on 24/05/22
//

#ifndef PROG_KMEANS_DISTANCE_H
#define PROG_KMEANS_DISTANCE_H

#include "vector.h"

/*
 * Although many distance return types may be left as integers,
 * when passing function pointers to the k-means routine,
 * a fixed signature will be expected.
 * Therefore, we convert all distance return types to double.
 */


double distance_euclid_int(const vector_int_t* p1, const vector_int_t* p2);

double distance_manhattan_int(const vector_int_t* p1, const vector_int_t* p2);

double distance_chebyshev_int(const vector_int_t* p1, const vector_int_t* p2);


#endif //PROG_KMEANS_DISTANCE_H
